EDIT - bug #6061

Add titlecache to nom author search
09/09/2016 01:01 PM - Andreas Miiller

Status: Closed Start date:

Priority: Highest Due date:

Assignee: Katja Luther % Done: 50%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 4.3

Severity: critical Found in Version: Release 4.2
Description

split from #5828

1 additional improvement would be to additionally add the titleCache in brackets after the abbrev title. This way you can better
distinguish records being equal in abbrev title. Also it allows searching simultanously on both using * at the beginning of the search
string

Associated revisions

Revision 8d5594ee - 08/25/2016 12:53 PM - Katja Luther

ref #5828 abbrevTitle and titlecache are displayed in nomenclatural selectionDialogs

Revision bdac48c7 - 09/12/2016 03:00 PM - Katja Luther

fix #6061: smaller changes

Revision 98838827 - 09/12/2016 03:00 PM - Katja Luther

fix #6061: search for titlecache if abbrev title is empty

Revision d33f8978 - 09/15/2016 10:40 AM - Katja Luther

ref #6061: remove the current selection as filter in nomenclatural author selection dialog

Revision 40dfdbc5 - 09/19/2016 01:12 PM - Katja Luther

fix #6061: search in titlecache and nomenclatural titleCache in getUuidAndAbbrevTitleCache

Revision 28027bed - 09/21/2016 09:37 AM - Katja Luther

fix #6061: add a null check for abbrevTitleCache and titleCache in comparator

Revision 03c8f07b - 10/07/2016 10:23 AM - Katja Luther

fix #6061: smaller changes

Revision d436abeb - 10/07/2016 10:23 AM - Katja Luther

fix #6061: search for titlecache if abbrev title is empty

Revision 38b82688 - 10/07/2016 10:23 AM - Katja Luther

fix #6061: search in titlecache and nomenclatural titleCache in getUuidAndAbbrevTitleCache

History

#1 - 09/09/2016 01:01 PM - Andreas Miiller
- Due date set to 05/26/2016
- Start date changed from 09/09/2016 to 05/26/2016

#2 - 09/09/2016 01:13 PM - Andreas Miiller
- Description updated

- Due date deleted (05/26/2016)
- Status changed from New to Feedback

- Target version changed from Unassigned CDM tickets to Release 4.3
- Start date changed from 05/26/2016 to 09/09/2016

- % Done changed from 0 to 50

The fix generally works, but we should further improve it.

1. If nomTitleCache and titleCache is equal we should show only 1 version to make the result less komplex. This is very often the case so an
important improvement.

2. | wonder if hyphen (-) is the best separator. Have you tried with brackets? For authors brackets might be better/more obvious. But e.g. for

references, which do have brackets included it might be less intuitive, but they also have hyphens sometimes. Maybe we should discuss with
users and keep it as it is for now.

#3 - 09/09/2016 01:50 PM - Andreas Miller

- Severity changed from normal to critical

Some more critical issues:

1. Ordering works on titleCache now but one would expect it to work on nomCache. E.g. if a person is "Zestpers. - Testperson" it appears within T
not Z.

2. Using a dot in the search does not work. E.g. if you search for an existing record "Exaut. - Exauthor" and you search by "Exaut." you get no

result. This is even the case when the record was just newly created so the return from the new person button does not show any result, which is
very critical.

#4 - 09/12/2016 03:00 PM - Katja Luther

- Status changed from Feedback to Resolved
Applied in changeset cdmlib:commit:cdmlib|bdac48c7613040ed609183f74552333ef1fb626¢.

#5 - 09/14/2016 12:31 PM - Katja Luther

- Assignee changed from Katja Luther to Andreas Mdiller

The ordering works now on the abbrev title and the search works for strings with a point at the end, but the object already selected does not show up
in the selection dialog. This is the same for all selection dialogs.

#6 - 09/14/2016 05:35 PM - Andreas Miiller
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Miiller to Katja Luther
If titteCache is same as nomTitle both versions are still shown. See note-#2

#7 - 09/14/2016 05:40 PM - Andreas Miuller

Katja Luther wrote:
... but the object already selected does not show up in the selection dialog. This is the same for all selection dialogs.

Is there a reason why it is such? Was it a requirement. Currently it looks strange to me but maybe there are use-cases from which it becomes more
clear. Is it explicitly coded in the code?

#8 - 09/14/2016 05:41 PM - Andreas Miuller

Ordering and dot search seem to work well now.

#9 - 09/14/2016 05:46 PM - Andreas Miuller

Search on titleCache with * at the beginning (additionally to the nom.title) still does not work. Is this difficult to implement? To me it looks like nice
feature so if difficult to implement we may want to create a new ticket for it. The current solution is not so intuitive because the user can see the
titteCache in the result and will wonder why when restricting the search in a way that it does not match the nom.title there comes no result back.
#10 - 09/15/2016 08:55 AM - Katja Luther

Andreas Miller wrote:
Katja Luther wrote:
... but the object already selected does not show up in the selection dialog. This is the same for all selection dialogs.

Is there a reason why it is such? Was it a requirement. Currently it looks strange to me but maybe there are use-cases from which it becomes
more clear. Is it explicitly coded in the code?

Yes, it is explicitely coded in the code. There is an attribute cdmBaseToBeFiltered in the base class of the selection dialog, which is filled with the
actual object. | think the original idea was that if | want to change something, | don't need the object selected before.

#11 - 09/15/2016 09:12 AM - Katja Luther
Katja Luther wrote:
Andreas Muller wrote:
Katja Luther wrote:
... but the object already selected does not show up in the selection dialog. This is the same for all selection dialogs.

Is there a reason why it is such? Was it a requirement. Currently it looks strange to me but maybe there are use-cases from which it
becomes more clear. Is it explicitly coded in the code?

Yes, it is explicitely coded in the code. There is an attribute cdmBaseToBeFiltered in the base class of the selection dialog, which is filled with the
actual object. | think the original idea was that if | want to change something, | don't need the object selected before.

I had a look in the code and the idea of this attribute was another one. The idea was for example if the selection dialog is used for a taxonrelationship
and it should not allowed to add the taxon itself, the selection dialog can filter the taxon out of the list. | will have a look in all selection dialogs and
adapt it.

#12 - 09/15/2016 09:25 AM - Katja Luther
Andreas Miller wrote:
Search on titleCache with * at the beginning (additionally to the nom.title) still does not work. Is this difficult to implement? To me it looks like nice

feature so if difficult to implement we may want to create a new ticket for it. The current solution is not so intuitive because the user can see the
titteCache in the result and will wonder why when restricting the search in a way that it does not match the nom.title there comes no result back.

What Do you mean? That for an * at the beginning the search is only on the titleCache?
Thats not really clear because it also could mean that the search is on the nom title but the search patter should be at the end of the string.
If we want to have this feature we should use another wildcard for this.

#13 - 09/15/2016 09:59 AM - Katja Luther
Katja Luther wrote:
Katja Luther wrote:
Andreas Miiller wrote:
Katja Luther wrote:
... but the object already selected does not show up in the selection dialog. This is the same for all selection dialogs.

Is there a reason why it is such? Was it a requirement. Currently it looks strange to me but maybe there are use-cases from which it
becomes more clear. Is it explicitly coded in the code?

Yes, it is explicitely coded in the code. There is an attribute cdmBaseToBeFiltered in the base class of the selection dialog, which is filled
with the actual object. | think the original idea was that if | want to change something, | don't need the object selected before.

| had a look in the code and the idea of this attribute was another one. The idea was for example if the selection dialog is used for a
taxonrelationship and it should not allowed to add the taxon itself, the selection dialog can filter the taxon out of the list. | will have a look in all
selection dialogs and adapt it.
Now | had another look in the history of the selectionDialogFactory and the usage of this cdmBaseToBeFiltered was the same as now from the

beginning. Nils wrote this comment but never used the attribute like this. Always the current selection was filtered.

#14 - 09/15/2016 01:26 PM - Katja Luther

now searching with * at the beginning of the search pattern searches on abbrevTitleCache and titleCache

#15 - 09/15/2016 01:55 PM - Katja Luther

- Assignee changed from Katja Luther to Andreas Miiller

#17 - 09/19/2016 01:06 PM - Andreas Miiller
- Assignee changed from Andreas Miiller to Katja Luther
Deduplication of equals caches looks good now.

Search on titleCache does not yet work. E.g. create a Person with nomTitle "Aaaa." and titleCache "Bbbb".
Searching for Aaaa works but "*Bbbb" does not return a result.

#18 - 09/19/2016 01:10 PM - Katja Luther

Andreas Muller wrote:

Deduplication of equals caches looks good now.

Search on titleCache does not yet work. E.g. create a Person with nomTitle "Aaaa." and titleCache "Bbbb".

Searching for Aaaa works but "*Bbbb" does not return a result.

sorry, it wasn't checked in yet...

#19 - 09/19/2016 01:12 PM - Katja Luther

- Status changed from Feedback to Resolved

Applied in changeset cdmlib:commit:cdmlib|40dfdbc5479f32292017fadeca45b8424dda4896.

#20 - 09/20/2016 10:23 AM - Katja Luther

- Assignee changed from Katja Luther to Andreas Mdiller

#21 - 09/20/2016 02:24 PM - Andreas Miiller
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Miiller to Katja Luther

With the above example Aaaa/Bbbb | get the following exception when exactly searching for "*B".
Entering "*Bb" works again and gives the correct result.

login :
editor version : 4.3.0.201609191958
server : /

schema version :
os : Windows Server 2012 6.2 amd64
java : 1.7.0_65
java.lang.NullPointerException
at java.text.RuleBasedCollator.compare (RuleBasedCollator. java:351)

at eu.etaxonomy.taxeditor.ui.dialog.selection.NomenclaturalAuthorSelectionDialog$2.compare (NomenclaturalAu

thorSelectionDialog. java:218)

at eu.etaxonomy.taxeditor.ui.dialog.selection.NomenclaturalAuthorSelectionDialog$2.compare (NomenclaturalAu

thorSelectionDialog.java:l)

at eu.etaxonomy.taxeditor.ui.dialog.selection.CdmFilteredItemsSelectionDialog$HistoryComparator.compare (Cd

mFilteredItemsSelectionDialog. java:3390)
at java.util.TimSort.binarySort (TimSort.java:265)
at java.util.TimSort.sort (TimSort. java:208)
at java.util.TimSort.sort (TimSort. java:173)

at java.util.Arrays.sort (Arrays.java:659)
at java.util.Collections.sort (Collections.java:217)

at eu.etaxonomy.taxeditor.ui.dialog.selection.CdmFilteredItemsSelectionDialog$ContentProvider.getSortedIte

ms (CdmFilteredItemsSelectionDialog. java:2925)

at eu.etaxonomy.taxeditor.ui.dialog.selection.CdmFilteredItemsSelectionDialog$ContentProvider.rememberResu
1t (CdmFilteredItemsSelectionDialog. java:2938)

at eu.etaxonomy.taxeditor.ui.dialog.selection.CdmFilteredItemsSelectionDialog$FilterJob.filterContent (CdmF
ilteredItemsSelectionDialog.java:2263)

at eu.etaxonomy.taxeditor.ui.dialog.selection.CdmFilteredItemsSelectionDialogS$FilterJob.internalRun (CdmFil
teredItemsSelectionDialog. java:2199)

at eu.etaxonomy.taxeditor.ui.dialog.selection.CdmFilteredItemsSelectionDialog$FilterJob.doRun (CdmFilteredI
temsSelectionDialog. java:2170)

at eu.etaxonomy.taxeditor.ui.dialog.selection.CdmFilteredItemsSelectionDialogS$FilterJob.run(CdmFilteredIte
msSelectionDialog. java:2157)

at org.eclipse.core.internal. jobs.Worker.run (Worker. java:54)

#22 - 09/21/2016 09:32 AM - Katja Luther
Andreas Muller wrote:

With the above example Aaaa/Bbbb | get the following exception when exactly searching for "*B".
Entering "*Bb" works again and gives the correct result.

login
editor version : 4.3.0.201609191958
server : /

schema version
os : Windows Server 2012 6.2 amd64
java : 1.7.0_65
java.lang.NullPointerException

at java.text.RuleBasedCollator.compare (RuleBasedCollator. java:351)

at eu.etaxonomy.taxeditor.ui.dialog.selection.NomenclaturalAuthorSelectionDialog$2.compare (Nomenclatural
AuthorSelectionDialog.java:218)

at eu.etaxonomy.taxeditor.ui.dialog.selection.NomenclaturalAuthorSelectionDialog$2.compare (Nomenclatural
AuthorSelectionDialog. java:1l)

at eu.etaxonomy.taxeditor.ui.dialog.selection.CdmFilteredItemsSelectionDialog$HistoryComparator.compare (
CdmFilteredItemsSelectionDialog. java:3390)

at java.util.TimSort.binarySort (TimSort.java:265)

at java.util.TimSort.sort (TimSort.java:208)

at java.util.TimSort.sort (TimSort.java:173)

at java.util.Arrays.sort (Arrays.java:659)

at java.util.Collections.sort (Collections.java:217)

at eu.etaxonomy.taxeditor.ui.dialog.selection.CdmFilteredItemsSelectionDialog$ContentProvider.getSortedI
tems (CdmFilteredItemsSelectionDialog. java:2925)

at eu.etaxonomy.taxeditor.ui.dialog.selection.CdmFilteredItemsSelectionDialog$ContentProvider.rememberRe
sult (CdmFilteredItemsSelectionDialog. java:2938)

at eu.etaxonomy.taxeditor.ui.dialog.selection.CdmFilteredItemsSelectionDialog$FilterJob.filterContent (Cd
mFilteredItemsSelectionDialog. java:2263)

at eu.etaxonomy.taxeditor.ui.dialog.selection.CdmFilteredItemsSelectionDialogS$FilterJob.internalRun (CdmF
ilteredItemsSelectionDialog. java:2199)

at eu.etaxonomy.taxeditor.ui.dialog.selection.CdmFilteredItemsSelectionDialog$FilterJob.doRun (CdmFiltere
dItemsSelectionDialog. java:2170)

at eu.etaxonomy.taxeditor.ui.dialog.selection.CdmFilteredItemsSelectionDialog$FilterJob.run (CdmFilteredI
temsSelectionDialog. java:2157)

at org.eclipse.core.internal. jobs.Worker.run (Worker. java:54)

This was also a data problem, the person BGBM had no abbrevTitleCache and therefore we got a NPE. Now the comparator checks for null in
abbrevTitleCache and titleCache. Normally this should not happen, because the abbrevTitleCache should not be null, but for older data we have to
check.

#23 - 09/21/2016 09:37 AM - Katja Luther

- Status changed from Feedback to Resolved

Applied in changeset taxeditor:commit:taxeditor|28027bed8148feb8c9a3cfdbd7e203e62ad51733.

#24 - 09/21/2016 09:39 AM - Katja Luther

- Status changed from Resolved to Closed
